<template>
   <Dialog :title="dialogTitle" v-model="dialogVisible">
      <el-select
        v-model="status"
        placeholder="请选择需求状态"
        clearable
        class="!w-240px"
      >
        <el-option label="已接单" :value="2" />
        <el-option label="已发布" :value="1" />
        <el-option label="未发布" :value="0" />
      </el-select>
      <template #footer>
        <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
        <el-button @click="dialogVisible = false">取 消</el-button>
      </template>
   </Dialog>
</template>

<script lang="ts">
export default {
   name: 'StatusDialog',
};
</script>

<script setup lang="ts">
import * as RequestApi from '@/api/request'

const emit = defineEmits(['success']);

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('修改需求单状态') // 弹窗的标题
const formLoading = ref(false);

const status = ref<RequestApi.NeedStatus | undefined>(undefined);
const needId = ref();

/** 打开弹窗 */
const open = async (id?: number, s?: RequestApi.NeedStatus) => {
  status.value = s;
  needId.value = id;
  dialogVisible.value = true;
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

const submitForm = async () => {
  // 校验表单
  if (typeof status.value !== 'number') {
    return;
  }
  // 提交请求
  formLoading.value = true
  try {
    await RequestApi.updateRequest({ id: needId.value, status: status.value });
    message.success('修改成功');
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}
</script>

<style lang="less" scoped>

</style>
